-------------------------------------------
--- Author: Ketho (EU-Boulderfist)		---
--- License: Public Domain				---
--- Created: 2011.11.27					---
--- Version: 0.3 [2011.12.02]			---
-------------------------------------------
--- Curse			http://www.curse.com/addons/wow/guildleveltooltip
--- WoWInterface	http://www.wowinterface.com/downloads/info20527-GuildLevelTooltip.html
--- Request			http://www.curse.com/forums/games/world-of-warcraft/addons/148517-got-a-request

local VERSION = 0.3
local NAME = ...

local db

local f = CreateFrame("Frame")

function f:ADDON_LOADED(name)
	if name == NAME then
		GuildLevelTooltipDB = GuildLevelTooltipDB or {}
		GuildLevelTooltipDB.version = VERSION
		local realm = GetRealmName()
		GuildLevelTooltipDB[realm] = GuildLevelTooltipDB[realm] or {}
		db = GuildLevelTooltipDB[realm]
	end
end

function f:INSPECT_READY(guid)
	local unit = InspectFrame.unit
	local name = GetGuildInfo(unit)
	local _, level, xp, members = GetInspectGuildInfo(unit)
	if not name then return end -- unit is guildless
	db[name] = db[name] or {}
	db[name][1] = level
	db[name][2] = members
	--db[name][3] = xp -- maybe useful for future versions
	--db[name][4] = time()
	--db[name][5] = date("%Y.%m.%d %H:%M")
end

function f:OnEvent(event, ...)
	self[event](self, ...)
end

f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("INSPECT_READY")
f:SetScript("OnEvent", f.OnEvent)

function f:OnTooltipSetUnit()
	local unit = select(2, GameTooltip:GetUnit())
	if not unit then return end
	local guild = db[GetGuildInfo(unit)]
	if not guild then return end
	GameTooltip:AddLine(format(GUILD_LEVEL, guild[1]))
	GameTooltip:AddLine(format(INSPECT_GUILD_NUM_MEMBERS, guild[2]))
	GameTooltip:Show() -- update tooltip
end

GameTooltip:HookScript("OnTooltipSetUnit", f.OnTooltipSetUnit)